<template>
  <div class="layers-panel vertical-menu-panel flex-grow-0 flex-column" v-bind:class="panelDisplayClass()">

    <!-- not minimized -->
    <div v-if="!minimized" class="d-flex flex-grow-1 flex-column">

      <!-- layer-panel-header -->
      <div class="layer-panel-header d-flex flex-row bg-primary pl-3 py-3">
        <h1 class="flex-grow-1 text-light mb-0">
          <span class="mr-2"><font-awesome-icon icon="layer-group"/></span>
          Camadas
        </h1>
        <button class="btn flex-grow-0 text-light mr-2 close-btn" @click="minimizePanel">
          <font-awesome-icon icon="angle-left"/>
        </button>
        <button class="btn flex-grow-0 text-light mr-2 close-btn" @click="closePanel">
          <font-awesome-icon icon="times"/>
        </button>
      </div>

      <!-- listings -->
      <div class="d-flex flex-grow-1 flex-row">
        <layer-groups-panel/>
        <filtered-layer-panel/>
      </div>
    </div>

    <!-- minimized -->
    <div v-else class="d-flex flex-grow-1 flex-column">
      <div class="layer-panel-header d-flex flex-row bg-primary py-3">
        <button class="btn flex-grow-1 text-light close-btn py-0 px-0" @click="maximizePanel">
          <h1 class="mx-0 my-0">
            <font-awesome-icon icon="layer-group"/>
          </h1>
        </button>
      </div>

      <div class="d-flex flex-grow-1 flex-row">
        <filtered-layer-panel/>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_WORKSPACE_CURRENT_PANEL, SET_WORKSPACE_LAYERS_PANEL_MINIMIZED } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LayerGroupsPanel from '@/workspace/components/layers/LayerGroupsPanel'
import FilteredLayerPanel from '@/workspace/components/layers/FilteredLayerPanel'

export default {
  name: 'layerspanel',

  mixins: [
    WorkspaceGetter
  ],

  props: {
    name: {
      type: String,
      required: true
    }
  },

  computed: {
    minimized: {
      get() {
        return this.$store.getters.workspaceLayersPanelMinimized(this.workspaceId)
      }
    },

    isCurrentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspaceId) === this.name
      }
    },
  },

  methods: {
    panelDisplayClass() {
      return {
        'd-flex': this.isCurrentPanel,
        'd-none': !this.isCurrentPanel,
      }
    },

    closePanel() {
      this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
        workspaceId: this.workspaceId,
        pane: null
      })
    },

    minimizePanel() {
      this.$store.commit(SET_WORKSPACE_LAYERS_PANEL_MINIMIZED, {
        workspaceId: this.workspaceId,
        value: true
      })
    },

    maximizePanel() {
      this.$store.commit(SET_WORKSPACE_LAYERS_PANEL_MINIMIZED, {
        workspaceId: this.workspaceId,
        value: false
      })
    },
  },

  components: {
    LayerGroupsPanel,
    FilteredLayerPanel,
  },
}
</script>
